#include "precompile.h"

#include "android.h"
#include "metamgr.h"
#include "android.ai.h"
#include "room.h"
#include "app.h"

Android::Android():Human()
{
    entity_type = ET_Player;
    entity_subtype = EST_Android;
    ai = new AndroidAI;
    ai->owner = this;
    ++App::Instance()->perf.entity_num[ET_Android];
}

Android::~Android()
{
    delete ai;
    ai = nullptr;
    --App::Instance()->perf.entity_num[ET_Android];
}

void Android::Initialize()
{
    Human::Initialize();
    health = meta->i->health();
    SetSkinInfo(14001);
    GiveEquip();
}

void Android::Update(int delta_time)
{
    if (a8::HasBitFlag(status, HS_Fly)) {
        pos = room->plane.curr_pos;
        room->grid_service.MoveHuman(this);
    }
    if (action_type != AT_None) {
        UpdateAction();
    }
    ai->Update(delta_time);
}

void Android::GiveEquip()
{
    MetaData::Equip* weapon_meta = MetaMgr::Instance()->GetEquip(robot_meta->i->weapon_id());
    if (weapon_meta) {
        weapons[GUN_SLOT1].weapon_idx = GUN_SLOT1;
        weapons[GUN_SLOT1].weapon_id = weapon_meta->i->id();
        weapons[GUN_SLOT1].weapon_lv = robot_meta->i->weapon_lv();
        weapons[GUN_SLOT1].ammo = 0;
        weapons[GUN_SLOT1].meta = weapon_meta;
        weapons[GUN_SLOT1].Recalc();
        curr_weapon = &weapons[GUN_SLOT1];
    }
}
