#pragma once

#include "cs_proto.pb.h"

class Bullet;
class Human;
struct FrameEvent
{
public:
    void AddAirDrop(int appear_time, int box_id, a8::Vec2 box_pos);
    void AddEmote(Human* hum, int emote_id);
    void AddShot(Human* hum);
    void AddBullet(Human* hum, a8::Vec2 born_pos, a8::Vec2 dir, float fly_distance);
    void AddExplosion(Bullet* bullet, int item_id, a8::Vec2 bomb_pos);
    void AddSmoke(Bullet* bullet, int item_id, a8::Vec2 pos);
    void AddExplosionEx(Human* sender, int item_id, a8::Vec2 bomb_pos, int effect);
    void AddBulletNumChg(Human* hum);
    void AddTankBulletNumChg(Human* hum);
    void AddTankOilValueChg(Human* hum);
    void AddTankOilMaxChg(Human* hum);
    void AddHpChg(Human* hum);

    void Clear();
private:
    ::google::protobuf::RepeatedPtrField<::cs::MFAirDrop> airdrops_;
    std::vector<std::tuple<Human*, ::cs::MFShot>> shots_;
    std::vector<std::tuple<Human*, ::cs::MFBullet>> bullets_;
    std::vector<std::tuple<Human*, ::cs::MFExplosion>> explosions_;
    std::vector<std::tuple<Human*, ::cs::MFSmoke>> smokes_;
    std::vector<std::tuple<Human*, ::cs::MFEmote>> emotes_;
    std::vector<Human*> chged_bullet_nums_;
    std::vector<Human*> chged_tank_bullet_nums_;
    std::vector<Human*> chged_tank_oil_value_;
    std::vector<Human*> chged_tank_oil_max_;
    std::vector<Human*> chged_hps_;

    friend class FrameMaker;
};
