#pragma once

struct PerfMonitor
{
    int max_run_delay_time = 0;
    int max_dispatchmsg_time = 0;
    int max_timer_idle = 0;
    long long out_data_size = 0;
    long long in_data_size = 0;
    long long read_count = 0;
    long long grid_chg_times = 0;
    long long test_times = 0;
    long long alive_count = 0;
    std::array<long long, 30> params = {};
    std::array<int, 30> entity_num = {};
};

namespace MetaData
{
    struct SafeArea;
    struct Equip;
    struct EquipUpgrade;
    struct MapTplThing;
}

namespace cs
{
    class MFWeapon;
    class MFSkin;
}

struct GasData
{
    GasMode_e gas_mode = GasInactive;
    a8::Vec2 pos_old;
    a8::Vec2 pos_old_bk;
    a8::Vec2 pre_pos_old;
    a8::Vec2 pos_new;
    float rad_old = 0.0f;
    float rad_new = 0.0f;
    float gas_progress = 0.0f;
    long long gas_start_frameno = 0;
    MetaData::SafeArea* old_area_meta = nullptr;
    MetaData::SafeArea* new_area_meta = nullptr;
    bool is_last_gas = false;
};

struct Weapon
{
    int weapon_idx = 0;
    int weapon_id = 0;
    int weapon_lv = 0;
    int ammo = 0;
    MetaData::Equip* meta = nullptr;
    MetaData::EquipUpgrade* upgrade_meta = nullptr;

    void ToPB(cs::MFWeapon* pb_obj);
    void Recalc();
    int GetClipVolume();
};

struct Skin
{
    int tank_uniid = 0;
    int skin_id = 0;
    int skin_lv = 0;

    void ToPB(cs::MFSkin* pb_obj);
};

struct PlayerStats
{
    int kills = 0;
    int damage_amount_in = 0;
    int damage_amount_out = 0;
    int heal_amount = 0;
    int rescue_member = 0;

    int history_time_alive = 0;
    int history_kills = 0;
    int history_damage_amount = 0;
    int history_heal_amount = 0;

    int gold = 0;
    int score = 0;
    int pass_score = 0;
    int rank_score = 0;

    std::vector<std::pair<int, int>> extra_drop;

    int killer_id = 0;
    std::string killer_name;
    int weapon_id = 0;

    int rank = 0;
};

struct Plane
{
    a8::Vec2 start_point;
    a8::Vec2 end_point;
    a8::Vec2 dir;
    a8::Vec2 curr_pos;
};

struct HumanAbility
{
    float speed = 0.0f;
    float damage_add = 0.0f;
    float def_add = 0.0f;
    float reflect_damage = 0.0f;
};

struct CarObject
{
    int car_id = 0;
    a8::Vec2 pos;
    bool taken = false;
};

struct BornPoint
{
    MetaData::MapTplThing* thing_tpl = nullptr;
    int player_num = 0;
    int android_num = 0;

    a8::Vec2 RandPoint() const;
};

#pragma pack(1)
struct ObjectSyncFlags
{
    unsigned char flags = 0;
    unsigned char last_sync_frameno = 0;
};
#pragma pack()
